﻿/*
 * Erstellt mit SharpDevelop.
 * Benutzer: User
 * Datum: 08.10.2008
 * Zeit: 17:09
 * 
 * Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO.Ports;

namespace SerialPort
{
	/// <summary>
	/// Description of MainForm.
	/// *********************************************************
	/// Demo-Programm in C#, kompiliert mit SharpDevelop IDE.
	/// Die hier gezeigte Programmierung erhebt keinen Anspruch
	/// auf "saubere, gut strukturierte" Vorgehensweise. Es soll 
	/// lediglich einen möglichen Lösungsansatz für die Kommuni-
	/// kation mit dem MFR-Modul über die serielle Schnittstelle
	/// aufzeigen. Getestet wurde dieser Demo-Viewer auf Win-XP. 
	/// *********************************************************
	/// </summary>
	public partial class MainForm : Form
	{
		string msg;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		void btnResetClick(object sender, EventArgs e)
		{
		textBox.Text = "Send reset command";
		//write reset command to serial port
		serialPort1.Write("X\r"); 
		}
		
		void process_msg()
		{
		// process single command line
		int i_bits,o_bits;
		
		switch (msg[0])
			{
			case 'I':
				i_bits = (msg[1] & 0xf) << 4;
				i_bits += msg[2] & 0xf;
				if ((i_bits & 0x80) > 0) cbi7.Checked = true; else cbi7.Checked = false;
				if ((i_bits & 0x40) > 0) cbi6.Checked = true; else cbi6.Checked = false;
				if ((i_bits & 0x20) > 0) cbi5.Checked = true; else cbi5.Checked = false;
				if ((i_bits & 0x10) > 0) cbi4.Checked = true; else cbi4.Checked = false;
				if ((i_bits & 0x08) > 0) cbi3.Checked = true; else cbi3.Checked = false;
				if ((i_bits & 0x04) > 0) cbi2.Checked = true; else cbi2.Checked = false;
				if ((i_bits & 0x02) > 0) cbi1.Checked = true; else cbi1.Checked = false;
				if ((i_bits & 0x01) > 0) cbi0.Checked = true; else cbi0.Checked = false;
				break;
			case 'O':
				o_bits = (msg[1] & 0xf) << 4;
				o_bits += msg[2] & 0xf;
				if ((o_bits & 0x80) > 0) cbo7.Checked = true; else cbo7.Checked = false;
				if ((o_bits & 0x40) > 0) cbo6.Checked = true; else cbo6.Checked = false;
				if ((o_bits & 0x20) > 0) cbo5.Checked = true; else cbo5.Checked = false;
				if ((o_bits & 0x10) > 0) cbo4.Checked = true; else cbo4.Checked = false;
				if ((o_bits & 0x08) > 0) cbo3.Checked = true; else cbo3.Checked = false;
				if ((o_bits & 0x04) > 0) cbo2.Checked = true; else cbo2.Checked = false;
				if ((o_bits & 0x02) > 0) cbo1.Checked = true; else cbo1.Checked = false;
				if ((o_bits & 0x01) > 0) cbo0.Checked = true; else cbo0.Checked = false;
				break;
			case 'X':
				textBox.Text = msg;
				break;
			}
		}
		
		void BtnSetOutClick(object sender, EventArgs e)
		{
		int o_bits=0;
		string cmd;
		
		if (cbo7.Checked) o_bits |= 0x80;
		if (cbo6.Checked) o_bits |= 0x40;
		if (cbo5.Checked) o_bits |= 0x20;
		if (cbo4.Checked) o_bits |= 0x10;
		if (cbo3.Checked) o_bits |= 0x08;
		if (cbo2.Checked) o_bits |= 0x04;
		if (cbo1.Checked) o_bits |= 0x02;
		if (cbo0.Checked) o_bits |= 0x01;
		textBox.Text = "Set outputs";
		cmd = "O";
		cmd += (char)('@' + (o_bits >> 4));
		cmd += (char)('@' + (o_bits & 0xf));
		cmd += '\r';
		//write output command to serial port
		serialPort1.Write(cmd); 
		}
		
		void BtnReadInputClick(object sender, EventArgs e)
		{
		//write input read command to serial port
		serialPort1.Write("I\r");
		
		textBox.Text = "Wait for input data ...";		// any nonsense
		}
		
		void BtnReadOutputClick(object sender, EventArgs e)
		{
		//write output read command to serial port
		serialPort1.Write("O\r");
		
		textBox.Text = "Wait for output data ...";		// any nonsense
		}
		
	
		void SerialPort1DataReceived(object sender, SerialDataReceivedEventArgs e)
		{
		int to_read;
		int rd_byte;
		
		to_read = serialPort1.BytesToRead;
		while (to_read > 0)
			{
			to_read--;
			rd_byte = serialPort1.ReadByte();
			switch (rd_byte)
				{
				case 10: 				// (LF) skip
					break;
				case 13:				// (CR) process received
					textBox.Text = "Data received";
					process_msg();
					msg = "";
					break;
				default:
					msg += (char)rd_byte;			// add to string
					break;
				}
			}
		}
		
		void MainFormFormClosing(object sender, FormClosingEventArgs e)
		{
		//close the port
		serialPort1.Close();
			
		}
		
		void MainFormShown(object sender, EventArgs e)
		{
		//configuring the serial port
		serialPort1.PortName="COM1";
		serialPort1.BaudRate=9600;
		serialPort1.DataBits=8;
		serialPort1.Parity=Parity.None;
		serialPort1.StopBits= StopBits.One;

		//opening the serial port
		msg = "";
		serialPort1.Open();
			
		}
		
		
	}
}
